
#include <sys/p2es_clock.h>
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))



enum {
	_clkfreq = 200_000_000,
};


/*
xinfreq =   20_000_000
clkfreq =  333_333_333
errfreq =     100_000

error = errfreq
for pppp = 0 to 15
  if pppp = 0 then post = 1 else post = pppp * 2
  for divd = 64 to 1 step -1
    Fpfd = round(xinfreq / divd)
    mult = round(clkfreq * (post * divd) / xinfreq)
    Fvco = round(xinfreq * mult / divd)
    Fout = round(Fvco / post)
    e = abs(Fout - clkfreq)
    if (e <= error) and (Fpfd >= 250000) and (mult <= 1024) and (Fvco >= 99e6) and ((Fvco <= 201e6) or (Fvco <= clkfreq + errfreq)) then
      result_divd = divd
      result_mult = mult
      result_post = post
      result_pppp = (pppp-1) & 15 '%1111 = /1, %0000..%1110 = /2..30
      result_Fpfd = Fpfd
      result_Fvco = Fvco
      result_Fout = Fout
      error = e
    endif
  next
next
*/
/*
static uint32_t  pll_calc_f( uint32_t targetfreq )  // returns a suitable _clkset() mode value, or 0 for an out-of-bounds result
{
	enum {
		_MINFPFD = 0.5e6,
	};
	float  Fpfd, Fvco, error, besterror = _MINFPFD;
	uint32_t  mode = 0;
	int  mult, post, divp, divd;

	for( post = 15; post >= 0; post-- )
	{
		divp = post ? post * 2 : 1;
//printf( " %d ", divp );
		for( divd = 1; divd <= 64; divd++ )
		{
			mult = (float)targetfreq * (float)divp * (float)divd / ((float)_XTALFREQ-0.5);
			Fpfd = (float)_XTALFREQ / (float)divd;
			Fvco = (float)mult * Fpfd;

printf( " %f ", Fpfd );
			if( (Fpfd >= _MINFPFD)
				&& (mult <= 1024)
				&& (Fvco >= 99.9e6)
				&& ((Fvco <= 201e6) || (Fvco <= (float)targetfreq + _MINFPFD)) )
			{
				error = fabs( Fvco / (float)divp - (float)targetfreq );
//printf( " %f ", error );
				if( error < besterror )
				{
					mode = 1<<24 | (divd-1)<<18 | (mult-1)<<8 | ((post-1)&0x0f)<<4 | 0x0b;  // %CC==%10 %SS==11
					besterror = error;
				}
			}
		}
	}

	return  mode;
}
*/


static uint32_t  div33( uint32_t dividend, uint32_t divisor )
{
	uint32_t  x;

	__asm {
		mov	x, divisor
		shr	x, #1
		add	dividend, x
		qdiv	dividend, divisor
		getqx	x
	}

	return  x;
}


static uint32_t  muldiv65( uint32_t mult1, uint32_t mult2, uint32_t divisor )
{
	uint32_t  x;

	__asm {
		qmul	mult1, mult2
		mov	x, divisor
		shr	x, #1
		getqx	mult1
		getqy	mult2
		add	mult1, x    wc
		addx	mult2, #0
		setq	mult2
		qdiv	mult1, divisor
		getqx	x
	}

	return  x;
}


static uint32_t  mul2div65( uint16_t mult1, uint16_t mult2, uint32_t mult32, uint32_t divisor )
{
	uint32_t  x;

	__asm {
		mul	mult1, mult2
		mov	x, mult1
	}

	return  muldiv65( x, mult32, divisor );
}


enum {
	_MINFPFD = 250_000,
};

static uint32_t  pll_calc( uint32_t targetfreq )  // returns a suitable _clkset() mode value, or 0 for an out-of-bounds result
{
	uint32_t  mult, divd, divp, post, Fpfd, Fvco, mode = 0;
	int32_t  error, besterror = _MINFPFD;

	for( post = 0; post <= 15; post++ )
	{
		divp = post ? post * 2 : 1;
		for( divd = 64; divd >= 1; divd-- )
		{
			mult = mul2div65( divp, divd, targetfreq, _XTALFREQ );
			Fvco = muldiv65( _XTALFREQ, mult, divd );
			Fpfd = div33( _XTALFREQ, divd );

			if( (Fpfd >= _MINFPFD)
				&& (mult <= 1024)
				&& (Fvco >= 100_000_000)
				&& ((Fvco <= 201_000_000) || (Fvco <= targetfreq + _MINFPFD)) )
			{
				error = abs( (int32_t)(div33( Fvco, divp ) - targetfreq) );
				if( error <= besterror )
				{
					mode = 1<<24 | (divd-1)<<18 | (mult-1)<<8 | ((post-1)&0x0f)<<4 | 0x0b;  // %CC==%10 %SS==11
					besterror = error;
				}
			}
		}
	}

	return  mode;
}



static uint32_t  pll_calc_divd( uint32_t targetfreq, uint32_t divd )  // returns a suitable _clkset() mode value, or 0 for an out-of-bounds result
{
	uint32_t  mult, divp, post, Fpfd, Fvco, mode = 0;
	int32_t  error, besterror = _MINFPFD;

	for( post = 0; post <= 15; post++ )
	{
		divp = post ? post * 2 : 1;
		mult = mul2div65( divp, divd, targetfreq, _XTALFREQ );
		Fvco = muldiv65( _XTALFREQ, mult, divd );
		Fpfd = div33( _XTALFREQ, divd );

		if( (Fpfd >= _MINFPFD)
			&& (mult <= 1024)
			&& (Fvco >= 20_000_000)
			&& ((Fvco <= 41_000_000) || (Fvco <= targetfreq + _MINFPFD)) )
		{
			error = abs( (int32_t)(div33( Fvco, divp ) - targetfreq) );
			if( error <= besterror )
			{
				mode = 1<<24 | (divd-1)<<18 | (mult-1)<<8 | ((post-1)&0x0f)<<4 | 0x0b;  // %CC==%10 %SS==11
				besterror = error;
			}
		}
	}

	return  mode;
}


/*
static uint32_t  pll_calc( uint32_t targetfreq )  // returns a suitable _clkset() mode value, or 0 for an out-of-bounds result
{
	enum {
		_MINFPFD = 500,  // units are kHz
		_XTLFRQ = (_XTALFREQ+500)/1000,  // units are kHz
	};
	int32_t  mult, divd, divp, post, Fpfd, Fvco, error, besterror = _MINFPFD;
	uint32_t  mode = 0;

	targetfreq = MAX( (targetfreq + 500) / 1000, 1 );  // convert to units of kHz

	for( post = 15; post >= 0; post-- )
	{
		divp = post ? post * 2 : 1;
		for( divd = 1; divd <= 64; divd++ )
		{
			Fpfd = (_XTLFRQ + (divd>>1)) / divd;  // units are kHz
			mult = ((int32_t)targetfreq * divp * divd + _XTLFRQ/2) / _XTLFRQ;
			Fvco = (_XTLFRQ * mult + (divd>>1)) / divd;  // units are kHz

			if( (Fpfd >= _MINFPFD)
				&& (mult <= 1024)
				&& (Fvco >= 99900)
				&& ((Fvco <= 201000) || (Fvco <= (int32_t)targetfreq + _MINFPFD)) )
			{
				error = (Fvco + (divp>>1)) / divp - targetfreq;  // units are kHz
				error = abs( error );
				if( error < besterror )
				{
					mode = 1<<24 | (divd-1)<<18 | (mult-1)<<8 | ((post-1)&0x0f)<<4 | 0x0b;  // %CC==%10 %SS==11
					besterror = error;
				}
			}
		}
	}

	return  mode;
}
*/


void  main( void )
{
	unsigned  idx, div;


	_waitms( 200 );
/*
//	for( idx = 40; idx <= 3500; idx++ )
	for( idx = 3494; idx <= 3494; idx++ )
	{
		uint32_t  mode = pll_calc( idx*100000 );
		uint32_t  mult = ((mode>>8)&0x3ff)+1;
		uint32_t  divd = ((mode>>18)&0x3f)+1;
		uint32_t  divp = MAX( (((mode>>4)+1)&0x0f)<<1, 1);
		uint32_t  Fvco = muldiv65( _XTALFREQ, mult, divd );
		uint32_t  Fclk = div33( Fvco, divp );

		_clkset( mode, idx*100000 );
		_pinstart( 40, P_NCO_FREQ | P_OE, idx/20, 0x8000_0000 );
//		_wxpin( 62 | 1<<6, 7 | (idx*100000 / 230_400)<<16 );
		_setbaud( 230400 );
		printf( " clkmode for %3d.%1d MHz is %08x : Fsysclk=%d Fvco=%d Ferror=%6d mult=%d divd=%d divp=%d\n", idx/10, idx%10, mode, Fclk, Fvco, abs( (int32_t)(idx*100000 - Fclk) ), mult, divd, divp );
		_waitms(2000);
	}
*/
	for( idx = 205; idx <= 205; idx++ )
	{
		for( div = 3; div <= 24; div++ )
		{
//			unsigned  divd = MIN( muldiv65( div, div, 9 ), 64 );
			unsigned  divd = 30;
			uint32_t  mode = pll_calc_divd( idx*100000, divd );

			if( mode )
			{
				unsigned  mult = ((mode>>8)&0x3ff)+1;
				unsigned  divp = MAX( (((mode>>4)+1)&0x0f)<<1, 1);
				uint32_t  Fvco = muldiv65( _XTALFREQ, mult, divd );
				uint32_t  Fclk = div33( Fvco, divp );

				_clkset( mode, idx*100000 );
				_pinstart( 40, P_NCO_FREQ | P_OE, idx/40, 0x8000_0000 );
//				_wxpin( 62 | 1<<6, 7 | (idx*100000 / 230_400)<<16 );
				_setbaud( 230400 );
				printf( " clkmode for %3d.%1d MHz is %08x : Fsysclk=%d Fvco=%d Ferror=%6d mult=%d divd=%d divp=%d\n", idx/10, idx%10, mode, Fclk, Fvco, abs( (int32_t)(idx*100000 - Fclk) ), mult, divd, divp );
				_waitms(2000);
	while(1);
			}
		}
	}

	while(1);
}

/*
It ranges from no effect with DIVD = 1 or 2 to large effect when DIVD > 9 plus several microseconds trigger delay.

Oddly, DIVD at multiples of 3 have relatively small jitter.  Eg: DIVD = 9 maxes out at just 3 (+1.5) ?s delay which produces jitter thickness of only 0.8 ns, while DIVD = 8 (which you'd expect to be alright being a power of 2) gives 6 (+1.5) ?s delay and jitter thickness of 1.2 ns.
DIVD = 10 is 3 (+1.5) ?s delay, 0.8 ns thickness.
DIVD = 11 is 8 (+1.5) ?s delay, 1.0 ns thickness.
No 12s generated.
DIVD = 17 is 5 (+1.5) ?s delay, 1.0 ns thickness.
DIVD = 20 is 5 (+1.5) ?s delay, 1.0 ns thickness.
*/
